%define major			5
%define libname_qt5		%mklibname %{name}qt5_ %{major}
%define libname_omemo_qt5	%mklibname %{name}omemoqt5_ %{major}
%define devname_qt5		%mklibname %{name}qt5 -d

%define libname_qt6		%mklibname %{name}qt6_ %{major}
%define libname_omemo_qt6	%mklibname %{name}omemoqt6_ %{major}
%define devname_qt6		%mklibname %{name}qt6 -d

%bcond_without	qt5
%bcond_without	qt6

Name:		qxmpp
Version:	1.10.1
Release:	%mkrel 1
Summary:	XMPP client and server library based on Qt
License:	LGPLv2+
Group:		System/Libraries
Url:		https://github.com/qxmpp-project/qxmpp/
Source0:	https://github.com/qxmpp-project/qxmpp/archive/v%{version}/%{name}-%{version}.tar.gz
### Qt5 build dependencies
%if %{with qt5}
BuildRequires:	cmake(Qca-qt5)
BuildRequires:	cmake(Qt5Core)
BuildRequires:	cmake(Qt5Gui)
BuildRequires:	cmake(Qt5Network)
BuildRequires:	cmake(Qt5Test)
BuildRequires:	cmake(Qt5Xml)
%endif
### Qt6 build dependencies
%if %{with qt6}
BuildRequires:	cmake(Qca-qt6)
BuildRequires:	cmake(Qt6Core5Compat)
BuildRequires:	cmake(Qt6Core)
BuildRequires:	cmake(Qt6Gui)
BuildRequires:	cmake(Qt6Network)
BuildRequires:	cmake(Qt6Test)
BuildRequires:	cmake(Qt6Xml)
%endif
BuildRequires:	cmake
BuildRequires:	doxygen
BuildRequires:	pkgconfig(gstreamer-1.0)
BuildRequires:	pkgconfig(libomemo-c)

%description
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket,
the core XMPP RFCs (RFC3920 and RFC3921) and XMPP extensions have been
nicely encapsulated into classes. QXmpp comes with full API
documentation, automatic tests and many examples.

QXmpp uses Qt extensively, and as such users need to a have working knowledge
of C++ and Qt basics (Signals and Slots and Qt data types).

Qt is the only third party library which is required to build QXmpp, but
libraries such as speex, vpx and theora enable additional features.

#----------------------------------------------------
### Qt5 ###

%package -n	%{libname_qt5}
Summary:	XMPP client and server library based on Qt5
Group:		System/Libraries

%description -n	%{libname_qt5}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket,
the core XMPP RFCs (RFC3920 and RFC3921) and XMPP extensions have been
nicely encapsulated into classes. QXmpp comes with full API
documentation, automatic tests and many examples.

QXmpp uses Qt extensively, and as such users need to a have working knowledge
of C++ and Qt basics (Signals and Slots and Qt data types).

Qt is the only third party library which is required to build QXmpp, but
libraries such as speex, vpx and theora enable additional features.

%files -n %{libname_qt5}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_libdir}/libQXmppQt5.so.%{major}
%{_libdir}/libQXmppQt5.so.%{version}

#----------------------------------------------------

%package -n	%{libname_omemo_qt5}
Summary:	XMPP client and server library based on Qt5
Group:		System/Libraries

%description -n	%{libname_omemo_qt5}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket,
the core XMPP RFCs (RFC3920 and RFC3921) and XMPP extensions have been
nicely encapsulated into classes. QXmpp comes with full API
documentation, automatic tests and many examples.

QXmpp uses Qt extensively, and as such users need to a have working knowledge
of C++ and Qt basics (Signals and Slots and Qt data types).

Qt is the only third party library which is required to build QXmpp, but
libraries such as speex, vpx and theora enable additional features.

%files -n %{libname_omemo_qt5}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_libdir}/libQXmppOmemoQt5.so.%{major}
%{_libdir}/libQXmppOmemoQt5.so.%{version}

#----------------------------------------------------

%package -n	%{devname_qt5}
Summary:	Development files for QXmpp (Qt5)
Group:		Development/C++
Requires:	%{libname_qt5} = %{version}-%{release}
Requires:	%{libname_omemo_qt5} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{name}-qt5-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-qt5-devel = %{version}-%{release}

Obsoletes:	%{_lib}qxmpp-devel < 1.4.0-4

%description -n	%{devname_qt5}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

The %{devname_qt5} package contains libraries and header files for
developing applications that use %{name} with Qt5.

%files -n %{devname_qt5}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_includedir}/QXmppQt5/
%{_libdir}/libQXmppQt5.so
%{_libdir}/libQXmppOmemoQt5.so
%{_libdir}/cmake/QXmpp/
%{_libdir}/cmake/QXmppQt5/
%{_libdir}/cmake/QXmppOmemoQt5/
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/QXmppQt5.pc

### End Qt5 ###

#----------------------------------------------------
### Qt6 ###

%package -n	%{libname_qt6}
Summary:	XMPP client and server library based on Qt6
Group:		System/Libraries

%description -n	%{libname_qt6}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket,
the core XMPP RFCs (RFC3920 and RFC3921) and XMPP extensions have been
nicely encapsulated into classes. QXmpp comes with full API
documentation, automatic tests and many examples.

QXmpp uses Qt extensively, and as such users need to a have working knowledge
of C++ and Qt basics (Signals and Slots and Qt data types).

Qt is the only third party library which is required to build QXmpp, but
libraries such as speex, vpx and theora enable additional features.

%files -n %{libname_qt6}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_libdir}/libQXmppQt6.so.%{major}
%{_libdir}/libQXmppQt6.so.%{version}

#----------------------------------------------------

%package -n	%{libname_omemo_qt6}
Summary:	XMPP client and server library based on Qt6
Group:		System/Libraries

%description -n	%{libname_omemo_qt6}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

QXmpp strives to be as easy to use as possible, the underlying TCP socket,
the core XMPP RFCs (RFC3920 and RFC3921) and XMPP extensions have been
nicely encapsulated into classes. QXmpp comes with full API
documentation, automatic tests and many examples.

QXmpp uses Qt extensively, and as such users need to a have working knowledge
of C++ and Qt basics (Signals and Slots and Qt data types).

Qt is the only third party library which is required to build QXmpp, but
libraries such as speex, vpx and theora enable additional features.

%files -n %{libname_omemo_qt6}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_libdir}/libQXmppOmemoQt6.so.%{major}
%{_libdir}/libQXmppOmemoQt6.so.%{version}

#----------------------------------------------------

%package -n	%{devname_qt6}
Summary:	Development files for QXmpp (Qt6)
Group:		Development/C++
Requires:	%{libname_qt6} = %{version}-%{release}
Requires:	%{libname_omemo_qt6} = %{version}-%{release}
Provides:	%{name}-qt6-devel = %{version}-%{release}
Provides:	lib%{name}-qt6-devel = %{version}-%{release}

%description -n	%{devname_qt6}
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

The %{devname_qt6} package contains libraries and header files for
developing applications that use %{name} with Qt6.

%files -n %{devname_qt6}
%doc AUTHORS CHANGELOG.md README.md
%license LICENSES/*
%{_includedir}/QXmppQt6/
%{_libdir}/libQXmppQt6.so
%{_libdir}/libQXmppOmemoQt6.so
%{_libdir}/cmake/QXmppQt6/
%{_libdir}/cmake/QXmppOmemoQt6/
%{_libdir}/pkgconfig/QXmppQt6.pc

### End Qt6 ###

#----------------------------------------------------

%package	doc
Summary:	Library documentation for QXmpp
Group:		Documentation
BuildArch:	noarch

%description	doc
QXmpp is a cross-platform C++ XMPP client and server library. It is written
in C++ and uses Qt framework.

This package contains library documentation for QXmpp.

%files doc
%doc AUTHORS CHANGELOG.md README.md SECURITY.md
%{_docdir}/%{name}/

#----------------------------------------------------

%prep
%autosetup

%build
### Build Qt5 ###
%if %{with qt5}
%define _vpath_builddir build-qt5
%cmake_qt5 \
	-DQT_VERSION_MAJOR=5 \
	-DBUILD_DOCUMENTATION=ON \
	-DWITH_GSTREAMER=ON \
	-DBUILD_OMEMO=ON
%cmake_build
%endif

### Build Qt6 ###
%if %{with qt6}
%define _vpath_builddir build-qt6
%cmake_qt6 \
	-DQT_VERSION_MAJOR=6 \
	-DBUILD_DOCUMENTATION=OFF \
	-DWITH_GSTREAMER=ON \
	-DBUILD_OMEMO=ON
%cmake_build
%endif

%install
%if %{with qt5}
%define _vpath_builddir build-qt5
%cmake_install
%endif

%if %{with qt6}
%define _vpath_builddir build-qt6
%cmake_install
%endif


%changelog
* Thu Mar 06 2025 daviddavid <daviddavid> 1.10.1-1.mga10
+ Revision: 2161176
- new version: 1.10.1

* Fri Jan 24 2025 daviddavid <daviddavid> 1.9.3-1.mga10
+ Revision: 2141223
- new version: 1.9.3

* Sun Dec 08 2024 daviddavid <daviddavid> 1.9.2-1.mga10
+ Revision: 2122909
- new version: 1.9.2

* Wed Oct 23 2024 daviddavid <daviddavid> 1.8.2-1.mga10
+ Revision: 2110801
- new version: 1.8.2

* Wed Aug 28 2024 daviddavid <daviddavid> 1.8.1-1.mga10
+ Revision: 2091959
- new version: 1.8.1

* Tue Aug 06 2024 daviddavid <daviddavid> 1.8.0-1.mga10
+ Revision: 2083696
- new version: 1.8.0

* Mon Jul 08 2024 daviddavid <daviddavid> 1.7.1-1.mga10
+ Revision: 2080333
- new version: 1.7.1

* Thu May 23 2024 daviddavid <daviddavid> 1.7.0-1.mga10
+ Revision: 2066271
- new version: 1.7.0
- libmajor is now 5

* Mon May 20 2024 daviddavid <daviddavid> 1.6.1-1.mga10
+ Revision: 2065263
- new version: 1.6.1

* Wed Feb 07 2024 daviddavid <daviddavid> 1.6.0-1.mga10
+ Revision: 2038298
- new version: 1.6.0

* Tue Feb 06 2024 daviddavid <daviddavid> 1.5.6-1.mga10
+ Revision: 2037918
- new version: 1.5.6

* Sun Jun 11 2023 daviddavid <daviddavid> 1.5.5-1.mga9
+ Revision: 1961617
- new version: 1.5.5
- enable Qt6 support
- enable libomemo-c and gstreamer support
- update lib and devel pkgs name

* Tue Oct 11 2022 ghibo <ghibo> 1.4.0-3.mga9
+ Revision: 1896295
- Rebuild against libvpx 1.12.0 (changed major from 6 to 7)

* Sun Apr 03 2022 umeabot <umeabot> 1.4.0-2.mga9
+ Revision: 1842361
- Mageia 9 Mass Rebuild

* Wed Mar 17 2021 daviddavid <daviddavid> 1.4.0-1.mga9
+ Revision: 1704010
- new version: 1.4.0

* Mon Jan 11 2021 daviddavid <daviddavid> 1.3.2-1.mga8
+ Revision: 1671097
- new version: 1.3.2

* Thu Dec 17 2020 umeabot <umeabot> 1.3.1-2.mga8
+ Revision: 1659722
- Rebuild for new Qt5

* Tue Aug 04 2020 daviddavid <daviddavid> 1.3.1-1.mga8
+ Revision: 1610868
- new version: 1.3.1

* Fri Apr 10 2020 daviddavid <daviddavid> 1.3.0-1.mga8
+ Revision: 1566057
- new version: 1.3.0

* Fri Feb 21 2020 daviddavid <daviddavid> 1.2.0-1.mga8
+ Revision: 1548300
- new version: 1.2.0
- now libmajor is 3

* Mon Feb 17 2020 umeabot <umeabot> 1.1.0-2.mga8
+ Revision: 1537109
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Fri Oct 25 2019 daviddavid <daviddavid> 1.1.0-1.mga8
+ Revision: 1455724
- new version: 1.1.0
- now libmajor is 2

* Fri Oct 18 2019 daviddavid <daviddavid> 1.0.1-1.mga8
+ Revision: 1454419
- new version: 1.0.1
- now libmajor is 1

* Mon Apr 01 2019 umeabot <umeabot> 1.0.0-2.mga7
+ Revision: 1384670
- Qt5 Rebuild

* Thu Jan 10 2019 daviddavid <daviddavid> 1.0.0-1.mga7
+ Revision: 1354356
- new version: 1.0.0

* Sun Sep 23 2018 umeabot <umeabot> 0.9.3-5.mga7
+ Revision: 1300762
- Mageia 7 Mass Rebuild

* Mon May 21 2018 daviddavid <daviddavid> 0.9.3-4.mga7
+ Revision: 1230929
- rebuild against latest libvpx (mga#23059)

* Fri Feb 02 2018 daviddavid <daviddavid> 0.9.3-3.mga7
+ Revision: 1198629
- rebuild for new libvpx 1.7.0

* Wed Jul 19 2017 cjw <cjw> 0.9.3-2.mga7
+ Revision: 1124879
- rebuild for new libvpx

* Wed Jun 15 2016 daviddavid <daviddavid> 0.9.3-1.mga6
+ Revision: 1021561
- initial package qxmpp

